{
TRegware 1.10 Demo
by WAK Productions
Programmed by Winston Kotzan

Demo for TRegware component for Delphi 5
}
unit demo1main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Regware, StdCtrls, ExtCtrls, regware2;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    TimeLimit: TEdit;
    Button2: TButton;
    StatusLabel: TLabel;
    Label3: TLabel;
    DaysLabel: TLabel;
    Label4: TLabel;
    User: TEdit;
    Button3: TButton;
    Label5: TLabel;
    Label6: TLabel;
    OrganizationLabel: TLabel;
    Label7: TLabel;
    LicenseLabel: TLabel;
    Label8: TLabel;
    CodeSizeLabel: TLabel;
    Code: TEdit;
    Reg: TRegwareII;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ShowNagScreen;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Expire;
    procedure UserKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UserChange(Sender: TObject);
    procedure RegClockChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses demo1form2;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Reg.Days := StrToInt(TimeLimit.Text);
  Reg.SetUnregistered;
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.License;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  if Reg.Registered then StatusLabel.Caption := 'Registered' else StatusLabel.Caption := 'Not Registered';
end;

procedure TForm1.ShowNagScreen;
begin
  // Must create form, because other forms may not have been created yet
  Form2 := TForm2.Create(Application);
  Form2.ShowModal;
  Form2.Release;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if Reg.CheckExpired then Expire;
  if Reg.Registered then StatusLabel.Caption := 'Registered'
  else begin
    StatusLabel.Caption := 'Not Registered';
    ShowNagScreen;
  end;
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.License;
  User.Text := Reg.License;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  CodeSizeLabel.Caption := IntToStr(Reg.RegCodeSize);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Reg.DoRegistration(User.Text, 'WAK Productions', Reg.CalculateCode(User.Text)) = false then
    ShowMessage('Unable to register program!');
  Code.Text := Reg.RegCode;
  OrganizationLabel.Caption := Reg.Organization;
  LicenseLabel.Caption := Reg.License;
  DaysLabel.Caption := IntToStr(Reg.DaysLeft);
  if Reg.Registered then StatusLabel.Caption := 'Registered' else StatusLabel.Caption := 'Not Registered';
end;

procedure TForm1.Expire;
begin
  ShowMessage('Program Expired');
  Application.Terminate;
end;

procedure TForm1.UserKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Code.Text := Reg.CalculateCode(User.Text);
end;

procedure TForm1.UserChange(Sender: TObject);
begin
  if Length(User.Text) > Reg.MaxChars then
  begin
    ActiveControl := User;
    raise Exception.Create('Too many characters!');
  end;
end;

procedure TForm1.RegClockChange(Sender: TObject);
begin
  ShowMessage('User has tampered with the system clock!');
end;

end.
